require_dependency "mdm/application_controller"

module Mdm
  module Enrollment
    class EnrollmentController < ApplicationController

      def enroll
        send_file Configuration.configuration_profile, {
                    disposition: 'attachment',
                    filename: 'Enroll.mobileconfig'
                  }
      end

      def checkin
        if params[:MessageType] == 'TokenUpdate'
          device_token_update
        end

        render nothing: true
      end

      private

      def device_token_update
        device = Mdm::Device.find_or_create_by(udid: params[:UDID])
        device.update!(
          unlock_token: params[:UnlockToken].try(:read),
          push_token: params[:Token].hexastring,
          push_magic: params[:PushMagic]
        )
      end
    end
  end
end

# TODO: move this somewhere
class StringIO

  def hexastring
    chars = []
    each_byte { |byte|
      chars << ("%02x" % byte)
    }
    return chars.join
  end

end
