require_dependency "mdm/application_controller"

module Mdm
  class Enrollment::DevicesController < ApplicationController

    before_action :sync, only: :index

    def index
      @devices = Device.all
      render json: { devices: @devices.map { |device|
                       device.as_json(except: [
                                        :unlock_token,
                                        :push_magic
                                      ])
                     }
                   }
    end

    def show
      @device = Device.find(params[:id])
      render json: { device: @device }
    end

    private

    def sync
      service = Enrollment::Sync.new
      service.start
    rescue Enrollment::Sync::DevicesCursorNotFound
      service = Enrollment::Devices.new
      service.start
    end

  end
end
