require_dependency "mdm/application_controller"

module Mdm
  class Enrollment::ProfilesController < ApplicationController

    def index
      @profiles = Profile.all
      render json: { profiles: @profiles }
    end

    def create
      service = Enrollment::CreateProfile.new
      service.params = params.except(:devices)

      if params[:devices]
        service.devices = Device.where(serial_number: params.require[:devices])
      end

      service.start
      render json: service.result
    end

    def update
      @profile = Mdm::Profile.find(params[:id])

      service = Mdm::Enrollment::AssignProfile.new
      service.profile = @profile
      service.devices = Mdm::Device.where(serial_number: params.require(:devices))
      service.start

      render json: service.result
    end

  end
end
