module Mdm
  class Command < ActiveRecord::Base

    module Status
      IDLE, ACKNOWLEDGED = ["Idle", "Acknowledged"]
    end

    belongs_to :device, class_name: 'Mdm::Device', foreign_key: 'mdm_device_id'

    scope :pending,   -> { where(status: Status::IDLE) } 
    scope :completed, -> { where(status: Status::ACKNOWLEDGED) } 

    def complete?
      status == Status::ACKNOWLEDGED
    end
    
    def self.available_commands
      Payload.methods.select { |method|
        method.to_s.start_with? 'payload_' }
    end

  end
end
