module Mdm
  class Device < ActiveRecord::Base

    has_many :commands, foreign_key: 'mdm_device_id'

    has_one :profile,
            primary_key: :profile_uuid,
            foreign_key: :profile_uuid

    def notify
      apn = Houston::Client.production
      apn.certificate = File.read("#{Rails.root}/certs/push.pem")

      notification = Houston::Notification.new(device: push_token)
      notification.custom_data = {
        mdm: push_magic
      }

      apn.push(notification)
    end

    def refresh!(data = {})
      update!(
        name: data[:DeviceName],
        udid: data[:UDID],
        serial_number: data[:SerialNumber],
        device_model: data[:Model],
        device_model_name: data[:ModelName],
        os_version: data[:OSVersion],
        build_version: data[:BuildVersion],
        imei: data[:IMEI],
        is_roaming: data[:IsRoaming],
        is_supervised: data[:IsSupervised],
        device_capacity: data[:DeviceCapacity],
        available_capacity: data[:AvailableDeviceCapacity]
      )
    end
  end
end
