module Mdm

  module Enrollment

    class AssignProfile < Service::Base

      attr_accessor :devices
      attr_accessor :profile

      def start
        params[:profile_uuid] = profile.profile_uuid
        params[:devices] = devices.map(&:serial_number)
        super
      end

      def path
        '/profile/devices'
      end

      def method
        :put
      end

      def result
        {
          profile_uuid: client.response['profile_uuid'],
          devices: client.response['devices']
        }
      end

    end

  end

end
