module Mdm

  module Enrollment

    class CreateProfile < Service::Base

      attr_accessor :devices

      attr_reader :profile

      def self.accepted_params
        [
          :devices,
          :profile_name,
          :org_magic,
          :url,
          :allow_pairing,
          :is_supervised,
          :is_mandatory,
          :await_device_configured,
          :is_mdm_removable,
          :support_phone_number,
          :support_email_address,
          :anchor_certs,
          :supervising_host_certs,
          :skip_setup_items,
          :department
        ]
      end

      def initialize
        super
        @devices = []
      end

      def start
        params[:devices] = devices.map(&:serial_number)
        # TODO: A string that uniquely identifies various services that are managed by a single organization.
        # wtf, so what do we use?
        params[:org_magic] = SecureRandom.uuid

        super

        @profile = Profile.new(params)
        @profile.profile_uuid = client.response['profile_uuid']
        @profile.save!
      end

      def path
        '/profile'
      end

      def method
        :post
      end

      def result
        if @profile.persisted?
          { profile: @profile.to_json }
        else
          { errors: @profile.errors }
        end
      end

    end

  end

end
