module Mdm

  module Enrollment

    class Profile < Service::Base

      def start
        super
        find_or_create_profile
      end

      def path
        '/profile'
      end

      def method
        :get
      end

      def result
        {
          profile: @profile.to_json
        }
      end

      private

      def find_or_create_profile
        @profile ||= begin
                       profile = Profile.find_or_create_by(
                         profile_uuid: client.response['profile_uuid']
                       )

                       profile.update!(
                         profile_uuid: client.response['profile_uuid'],
                         profile_name: client.response['profile_name'],
                         url: client.response['url'],
                         is_supervised: client.response['is_supervised'],
                         allow_pairing: client.response['allow_pairing'],
                         is_mandatory: client.response['is_mandatory'],
                         await_device_configured: client.response['await_device_configured'],
                         is_mdm_removable: client.response['is_mdm_removable'],
                         department: client.response['department'],
                         org_magic: client.response['org_magic'],
                         support_phone_number: client.response['support_phone_number'],
                         support_email_address: client.response['support_email_address'],
                         anchor_certs: client.response['anchor_certs'],
                         supervising_host_certs: client.response['supervising_host_certs'],
                         skip_setup_items: client.response['skip_setup_items'],
                         devices: client.response['devices']
                       )

                       profile
                     end
      end


    end

  end

end
