module Mdm

  module Enrollment

    class Sync < Devices

      class DevicesCursorNotFound < StandardError
      end

      def path
        '/devices/sync'
      end

      def cursor
        @cursor ||=
          begin
            cursor = Mdm::Cursor.where(
              service: Mdm::Cursor::SYNC
            ).first || begin
                         # Create sync cursor based on Device service cursor
                         device_cursor = Cursor.where(
                           service: Cursor::DEVICES).first

                         # Raise if no device service cursor found
                         # Device service must be called first
                         if device_cursor.nil?
                           raise DevicesCursorNotFound
                         end

                         # Use device service cursor to create sync service cursor
                         Cursor.create(
                           service: Cursor::SYNC,
                           content: device_cursor.content)
                       end
            cursor
          end
      end

    end

  end

end
