module Mdm
  class Railtie < Rails::Railtie
    initializer 'mdm.mime_types' do
      Mime::Type.register 'application/plist', :plist, [
                            'application/x-apple-aspen-mdm-checkin',
                            'application/x-apple-aspen-mdm'
                          ]
    end

    initializer 'mdm.plist_parser' do
      require 'plist'
      
      Rails.application.config.middleware.delete ActionDispatch::ParamsParser
      Rails.application.config.middleware.use(
        ActionDispatch::ParamsParser, {
          Mime::PLIST => lambda do |body|
            Plist.parse_xml(body)
          end
        })
    end
  end
end
